import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import java.util.stream.Stream;

public class StreamApp {
    public static void main(String[] args) throws IOException {
////         1. created integer stream from 1 to 9 with IntStream
//        IntStream
//                .range(1, 10)
//                .forEach(System.out::print);
//        System.out.println();
//
//        // 2. create integer stream skipping first 5 elements
//        IntStream
//                .range(1, 10)
//                .skip(5)
//                .forEach(System.out::print);

//        // 3. create integer stream then sum it.
//        System.out.println(IntStream
//                .range(1,5)
//                .sum());

//        //4. Stream.of, create stream of Strings, then sort and find first element
//        Stream.of("qadeer", "jack", "hammad", "alex")
//                .sorted()
//                .findFirst()
//                .ifPresent(System.out::println);

//       // 5. sort, filter and print
//        String[] names = {"Kevin", "Alex", "Jimmy", "Carl", "Ben", "Adam"};
//        Arrays.stream(names)
//                .filter(x -> x.startsWith("A"))
//                .sorted()
//                .forEach(System.out::println);

//        // 6. average of squares
//        // won't allow non-primitive types for list of integers because it allows null values
//        // which leads to errors when using sum and average methods
//        int[] numbers = {1,2,3,4,5};
//        Arrays.stream(numbers)
//                .map(x -> x * x)
//                .average()
//                .ifPresent(System.out::println); // average returns an optionalDouble hence we can use ifPresent() method

//        // 7. map all strings of a list to lowerCase
//        // filter a list of strings by their last letter
//        List<String> names = Arrays.asList("Kevin", "Alex", "Jimmy", "Carl", "Ben", "Adam");
//        names
//                .stream()
//                .map(String::toLowerCase)
//                .filter(x -> x.endsWith("m"))
//                .forEach(System.out::println);

//        // 8. Stream rows from a text file, sort, filter, and print
//        // must add throws ioException in main method
//        Stream<String> names = Files.lines(Paths.get("names.txt"));
//        names
//                .sorted()
//                .filter(x -> x.startsWith("Q"))
//                .forEach(System.out::println);
//        names.close();
//
//        String name = "Qadeer";
//        String n1 = "Ahmed";
//        String n2 = "Naveed";
//        String n3 = "Kevin";
//        String n4 = "Brad";
//        List<String> nameList = Arrays.asList(n1,n2,n3,n4);
//        nameList
//                .stream()
//                .map(x -> {
//                    if (Objects.equals(x, "Naveed")) {
//                        x = name;
//                    }
//                    return x;
//                })
//                .forEach(System.out::println);

        // 9. Stream rows from a text file and filter by letters of name
//        List<String> names = Files.lines(Paths.get("names.txt"))
//                .filter(x -> x.contains("Ka")) // case sensitive
//                .collect(Collectors.toList());
//
//        names.forEach(System.out::println);

        // 10. Stream rows from a csv file and count rows
//        Stream<String> data = Files.lines(Paths.get("data.csv"));
//        long rowCount =  data
//                .map(x -> x.split(","))
//                .filter(x -> x.length == 3)
//                .count();
//        System.out.println(rowCount);
//        data.close();


//        // 11. Stream rows from a csv file and parse date
//        Stream<String> data2 = Files.lines(Paths.get("data.csv"));
//        data2
//                .map(x -> x.split(","))
//                .filter(x -> x.length == 3)
//                .filter(x -> Integer.parseInt(x[1]) > 23)
//                .forEach(x -> System.out.println(x[0] + " "  + x[1] + " " + x[2]));

//        // 12. Stream rows from csv, store fields in a HashMap
//        Stream<String> data3 = Files.lines(Paths.get("data.csv"));
//        Map<String, Integer> mapStore = new HashMap<>();
//        mapStore = data3
//                .map(x -> x.split(","))
//                .filter(x -> x.length == 3)
//                .filter(x -> Integer.parseInt(x[1]) > 23)
//                .collect(Collectors.toMap(
//                        x -> x[0],
//                        x -> Integer.parseInt(x[1])));
//        data3.close();
//        for (String key: mapStore.keySet()) {
//            System.out.println(key + " " + mapStore.get(key));
//        }

//        // 13. Reduction - sum
//        double total = Stream.of(1.1,5.3,1.3,6.1)
//                .reduce(0.0, (Double a, Double b) -> a + b);
//        System.out.println("Total = " + total);

//        // 14. Reduction - summary statistics
//        // returns the count, sum, min, average, and max of integer list
//        IntSummaryStatistics summary = IntStream.of(1,5,2,1,8)
//                .summaryStatistics();
//        System.out.println(summary);

//        List<Integer> integerList = Arrays.asList(1,2,3,4,5);
//        Integer sums = integerList
//                .stream()
//                .reduce(0, (x, y) -> x + y);// x = result of previous application
//        // y = current element in the stream
//        // 0 = initial value
//        System.out.println(sums);

//        List<Integer> integerList = Arrays.asList(1,2,3,-4,5);
//        Integer sums = integerList
//                .stream()
//                .reduce(0, CheckValueUtil::add);
//        System.out.println(sums);

//        List<Integer> integers = Arrays.asList(1,2,3,4,5);
//        Integer sums = integers.stream()
//                .mapToInt(Integer::intValue)
//                .sum();
//        System.out.println(sums);

//        Item item1 = new Item(1, 10);
//        Item item2 = new Item(2, 20);
//        Item item3 = new Item(3, 33);
//        Item item4 = new Item(4, 45);
//
//        List<Item> items = Arrays.asList(item1, item2, item3, item4);
//
//        Integer sum = items.stream()
//                .map(Item::getPrice)
//                .reduce(0,Integer::sum);
//

//        Integer sum1 = items.stream()
//                .map(Item::getPrice)
//                .reduce(0, CheckValue::add);
//
//        Integer sum2 = items.stream()
//                .map(Item::getPrice)
//                .reduce(0, (a, b) -> a + b);
//
//        Integer sum3 = items.stream()
//                .map(Item::getPrice)
//                .collect(Collectors.summingInt(Integer::intValue));
//
//        Integer sum4 =
//        items.stream()
//                .mapToInt(Item::getPrice)
//                .sum();
//
//        System.out.println(sum);
//        System.out.println(sum1);
//        System.out.println(sum2);
//        System.out.println(sum3);
//        System.out.println(sum4);


//        String string = "One 1 Two 2 Three 3 Four 4 Five 5 Six 6";
//        List<String> sums = Arrays.stream(string.split(" "))
//                .filter((s) -> !s.matches("\\d"))
//                .collect(Collectors.toList());
//
//        System.out.println(sums);

//        // instance methods of particular objects
//        CheckValue value = new CheckValue();
//        List<Integer> numbers = Arrays.asList(1,2,3,4,5,6);
//        Integer sums = numbers.stream()
//                .reduce(0, value::add);
//        System.out.println(sums);

//        List<Integer> ids = Arrays.asList(1,2,3,4,5);
//        Item[] items = ids.stream()
//                .map(Item::new)
//                .toArray(Item[]::new);


//        System.out.println(Arrays.toString(items));
//        Arrays.stream(items).map(Item::toString).forEach(System.out::println);



    }
}
